/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookPageConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookPageConnectorFormAllOf{}

// FacebookPageConnectorFormAllOf struct for FacebookPageConnectorFormAllOf
type FacebookPageConnectorFormAllOf struct {
	// Authorizer ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Facebook Page ID.
	PageId *string `json:"pageId,omitempty"`
	// Metrics
	Metric []string `json:"metric,omitempty"`
	// Data labels
	DataLabel []string `json:"dataLabel,omitempty"`
	// Data range expression
	DateRange *string `json:"dateRange,omitempty"`
}

// NewFacebookPageConnectorFormAllOf instantiates a new FacebookPageConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookPageConnectorFormAllOf() *FacebookPageConnectorFormAllOf {
	this := FacebookPageConnectorFormAllOf{}
	return &this
}

// NewFacebookPageConnectorFormAllOfWithDefaults instantiates a new FacebookPageConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookPageConnectorFormAllOfWithDefaults() *FacebookPageConnectorFormAllOf {
	this := FacebookPageConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *FacebookPageConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *FacebookPageConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *FacebookPageConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *FacebookPageConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *FacebookPageConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *FacebookPageConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetPageId returns the PageId field value if set, zero value otherwise.
func (o *FacebookPageConnectorFormAllOf) GetPageId() string {
	if o == nil || IsNil(o.PageId) {
		var ret string
		return ret
	}
	return *o.PageId
}

// GetPageIdOk returns a tuple with the PageId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorFormAllOf) GetPageIdOk() (*string, bool) {
	if o == nil || IsNil(o.PageId) {
		return nil, false
	}
	return o.PageId, true
}

// HasPageId returns a boolean if a field has been set.
func (o *FacebookPageConnectorFormAllOf) HasPageId() bool {
	if o != nil && !IsNil(o.PageId) {
		return true
	}

	return false
}

// SetPageId gets a reference to the given string and assigns it to the PageId field.
func (o *FacebookPageConnectorFormAllOf) SetPageId(v string) {
	o.PageId = &v
}

// GetMetric returns the Metric field value if set, zero value otherwise.
func (o *FacebookPageConnectorFormAllOf) GetMetric() []string {
	if o == nil || IsNil(o.Metric) {
		var ret []string
		return ret
	}
	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorFormAllOf) GetMetricOk() ([]string, bool) {
	if o == nil || IsNil(o.Metric) {
		return nil, false
	}
	return o.Metric, true
}

// HasMetric returns a boolean if a field has been set.
func (o *FacebookPageConnectorFormAllOf) HasMetric() bool {
	if o != nil && !IsNil(o.Metric) {
		return true
	}

	return false
}

// SetMetric gets a reference to the given []string and assigns it to the Metric field.
func (o *FacebookPageConnectorFormAllOf) SetMetric(v []string) {
	o.Metric = v
}

// GetDataLabel returns the DataLabel field value if set, zero value otherwise.
func (o *FacebookPageConnectorFormAllOf) GetDataLabel() []string {
	if o == nil || IsNil(o.DataLabel) {
		var ret []string
		return ret
	}
	return o.DataLabel
}

// GetDataLabelOk returns a tuple with the DataLabel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorFormAllOf) GetDataLabelOk() ([]string, bool) {
	if o == nil || IsNil(o.DataLabel) {
		return nil, false
	}
	return o.DataLabel, true
}

// HasDataLabel returns a boolean if a field has been set.
func (o *FacebookPageConnectorFormAllOf) HasDataLabel() bool {
	if o != nil && !IsNil(o.DataLabel) {
		return true
	}

	return false
}

// SetDataLabel gets a reference to the given []string and assigns it to the DataLabel field.
func (o *FacebookPageConnectorFormAllOf) SetDataLabel(v []string) {
	o.DataLabel = v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *FacebookPageConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *FacebookPageConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *FacebookPageConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

func (o FacebookPageConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookPageConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.PageId) {
		toSerialize["pageId"] = o.PageId
	}
	if !IsNil(o.Metric) {
		toSerialize["metric"] = o.Metric
	}
	if !IsNil(o.DataLabel) {
		toSerialize["dataLabel"] = o.DataLabel
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	return toSerialize, nil
}

type NullableFacebookPageConnectorFormAllOf struct {
	value *FacebookPageConnectorFormAllOf
	isSet bool
}

func (v NullableFacebookPageConnectorFormAllOf) Get() *FacebookPageConnectorFormAllOf {
	return v.value
}

func (v *NullableFacebookPageConnectorFormAllOf) Set(val *FacebookPageConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookPageConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookPageConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookPageConnectorFormAllOf(val *FacebookPageConnectorFormAllOf) *NullableFacebookPageConnectorFormAllOf {
	return &NullableFacebookPageConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableFacebookPageConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookPageConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
